stages:
  - build-image
  - lint
  - release

before_script:
  - HELM_PROJECT=$(git describe --abbrev=0 --tags HEAD | cut -d '-' -f1)

build_base_image:
  stage: build-image
  image: docker:20.10.21
  services:
    - docker:20.10.21-dind
  variables:
    CONTAINER_IMAGE_NAME: "$CI_REGISTRY_IMAGE:latest"
  before_script:
  - docker login -u $CI_REGISTRY_USERNAME -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  script:
  - docker build -t $CONTAINER_IMAGE_NAME . --no-cache
  - docker push $CONTAINER_IMAGE_NAME
  only:
    changes:
      - "Dockerfile"
    refs:
      - master

helm_lint:
  stage: lint
  image: "$CI_REGISTRY_IMAGE:latest"
  script:
    - echo $HELM_PROJECT
    - helm lint charts/$HELM_PROJECT
  rules:
    - if: '$CI_COMMIT_TAG'
      changes: 
      - charts/**/*


helm_release:
  stage: release
  image: "$CI_REGISTRY_IMAGE:latest"  
  script:
    - cd charts/$HELM_PROJECT
    - helm repo add --username $CI_REGISTRY_USERNAME --password $CI_REGISTRY_PASSWORD deployment $CI_REGISTRY_URL
    - helm package .
    - helm cm-push . deployment
  needs:
    - helm_lint
  rules:
    - if: '$CI_COMMIT_TAG'
      changes: 
      - charts/**/*